##parameters=subject,author,message,parent_id=None,comment_mode=0,REQUEST=None

# $Id: forum_post.py,v 1.8 2003/10/30 08:29:16 epietrig Exp $

new_id = context.computeId(compute_from=subject)
doc = context.getForumObject(comment_mode)

if (not doc) and comment_mode:
    #the forum holding comments might not exist if this is
    #the first post ; in this case create it
    doc = context.portal_discussion.addForum(context)

if (not author) or (author == ""):
    msg = "Pseudo obligatoire"
    return context.forum_post_form(error_message=msg)

if (not parent_id) or parent_id.isspace():
    #FIXME: for doc comment forums, parent_id is sometimes '',
    #which is not equivalent to None as far as the thread
    #manager is concerned, so we put it back to None in those
    #cases ; but it would be better to find why it gets '' instead
    #of None when going through "New Thread"
    parent_id = None

new_id = doc.addForumPost(id=new_id, subject=subject, author=author,
                          message=message, parent_id=parent_id)

if REQUEST is not None:
    if comment_mode:
        REQUEST.RESPONSE.redirect(context.absolute_url()+"/?comment_id="+new_id)
    else:
        REQUEST.RESPONSE.redirect(context.absolute_url()+"/?post_id="+new_id)

